"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var errors_1 = require("./errors");
var lodash_1 = require("lodash");
function compose() {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return fns.reduceRight(function (prevFn, nextFn) { return function (value) { return nextFn(prevFn(value)); }; }, function (value) { return value; });
}
exports.compose = compose;
function withName(name) {
    return function (target) {
        return Object.entries(target).reduce(function (acc, _a) {
            var key = _a[0], resolverFn = _a[1];
            var _b;
            return (__assign({}, acc, (_b = {}, _b["" + key + name] = resolverFn, _b)));
        }, {});
    };
}
exports.withName = withName;
function just(scopes) {
    return function (target) {
        return Object.entries(target).reduce(function (acc, _a) {
            var key = _a[0], resolverFn = _a[1];
            var _b;
            if ((Array.isArray(scopes) && !scopes.includes(key)) ||
                (!Array.isArray(scopes) && scopes !== key)) {
                return acc;
            }
            return __assign({}, acc, (_b = {}, _b[key] = resolverFn, _b));
        }, {});
    };
}
exports.just = just;
function defaultMutator(model, entity, _a, options) {
    var _b = model.name.toLowerCase(), input = _a[_b];
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, Promise.all(Object.entries(input).map(function (_a) {
                        var key = _a[0], value = _a[1];
                        return __awaiter(_this, void 0, void 0, function () {
                            var mapped;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        if (options.keyBlackList.includes(key)) {
                                            return [2 /*return*/];
                                        }
                                        if (typeof options.mapper !== 'function') {
                                            entity[key] = value;
                                            return [2 /*return*/];
                                        }
                                        return [4 /*yield*/, options.mapper(value, key, entity)];
                                    case 1:
                                        mapped = _b.sent();
                                        if (mapped !== undefined) {
                                            entity[key] = mapped;
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        });
                    }))];
                case 1:
                    _c.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function defaultMapper(value, field, entity) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(typeof entity[field] === 'function')) return [3 /*break*/, 2];
                    return [4 /*yield*/, entity[field](value)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
                case 2: return [2 /*return*/, value];
            }
        });
    });
}
var defaultMutators = {
    create: { fn: defaultMutator, options: { keyBlackList: [] } },
    update: { fn: defaultMutator, options: { keyBlackList: ['id'] } },
};
var defaultMappers = {
    create: defaultMapper,
    update: defaultMapper,
};
function generateMutations(model, options) {
    var _this = this;
    var _a = lodash_1.merge({
        hooks: {
            preCreate: null,
            postCreate: null,
            preUpdate: null,
            postUpdate: null,
            preRemove: null,
            postRemove: null,
        },
        mutators: defaultMutators,
        mappers: defaultMappers,
    }, options || {}), hooks = _a.hooks, mutators = _a.mutators, mappers = _a.mappers;
    return {
        create: function (rootValue, args, context, info) { return __awaiter(_this, void 0, void 0, function () {
            var repository, entity, savedEntity;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        repository = context.connection.getRepository(model);
                        entity = repository.create();
                        if (!(typeof hooks.preCreate === 'function')) return [3 /*break*/, 2];
                        return [4 /*yield*/, hooks.preCreate(entity, rootValue, args, context, info)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [4 /*yield*/, mutators.create.fn(model, entity, args, __assign({ mapper: mappers.create }, mutators.create.options))];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, repository.save(entity)];
                    case 4:
                        savedEntity = _a.sent();
                        if (!(typeof hooks.postCreate === 'function')) return [3 /*break*/, 6];
                        return [4 /*yield*/, hooks.postCreate(savedEntity, rootValue, args, context, info)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6: return [2 /*return*/, savedEntity];
                }
            });
        }); },
        update: function (rootValue, args, context, info) { return __awaiter(_this, void 0, void 0, function () {
            var id, repository, entity, savedEntity;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        id = args.id;
                        repository = context.connection.getRepository(model);
                        return [4 /*yield*/, repository.findOne(id)];
                    case 1:
                        entity = _a.sent();
                        if (!entity) {
                            throw new errors_1.NotFoundError("Could not find " + model.name + " for id " + id);
                        }
                        if (!(typeof hooks.preUpdate === 'function')) return [3 /*break*/, 3];
                        return [4 /*yield*/, hooks.preUpdate(entity, rootValue, args, context, info)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [4 /*yield*/, mutators.update.fn(model, entity, args, __assign({ mapper: mappers.update }, mutators.update.options))];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, repository.save(entity)];
                    case 5:
                        savedEntity = _a.sent();
                        if (!(typeof hooks.postUpdate === 'function')) return [3 /*break*/, 7];
                        return [4 /*yield*/, hooks.postUpdate(savedEntity, rootValue, args, context, info)];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7: return [2 /*return*/, savedEntity];
                }
            });
        }); },
        remove: function (rootValue, args, context, info) { return __awaiter(_this, void 0, void 0, function () {
            var _a, id, repository, entity, removedEntity;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = model.name.toLowerCase(), id = args[_a].id;
                        repository = context.connection.getRepository(model);
                        return [4 /*yield*/, repository.findOne(id)];
                    case 1:
                        entity = _b.sent();
                        if (!entity) {
                            throw new errors_1.NotFoundError("Could not find " + model.name + " for id " + id);
                        }
                        if (!(typeof hooks.preRemove === 'function')) return [3 /*break*/, 3];
                        return [4 /*yield*/, hooks.preRemove(entity, rootValue, { id: id }, context, info)];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3: return [4 /*yield*/, repository.remove(entity)];
                    case 4:
                        removedEntity = _b.sent();
                        if (!(typeof hooks.postRemove === 'function')) return [3 /*break*/, 6];
                        return [4 /*yield*/, hooks.postRemove(removedEntity, rootValue, { id: id }, context, info)];
                    case 5:
                        _b.sent();
                        _b.label = 6;
                    case 6: return [2 /*return*/, __assign({}, entity, { id: id })];
                }
            });
        }); },
    };
}
exports.generateMutations = generateMutations;
//# sourceMappingURL=generateMutations.js.map