"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const shell = require("shelljs");
const chalk_1 = require("chalk");
const ora = require("ora");
const spawn = require("cross-spawn-promise");
const tic = chalk_1.default.green('✓');
const tac = chalk_1.default.red('✗');
const installYeoman = () => __awaiter(this, void 0, void 0, function* () {
    const spinner = ora('Installing Yeoman...');
    spinner.start();
    const command = 'npm';
    const args = ['install', '-g', 'yo'];
    const options = {
        shell: true,
        stdio: '',
    };
    try {
        yield spawn(command, args, options);
        spinner.stop();
        console.log(`${tic} Yeoman installed!`);
    }
    catch (error) {
        spinner.stop();
        console.error(`${tac} There was an error while trying to install Yeoman:`, error);
    }
});
exports.verifyYeoman = () => __awaiter(this, void 0, void 0, function* () {
    if (!shell.which('yo')) {
        console.error(`${tac} GraphQL CLI requires Yeoman to be installed.`);
        yield installYeoman();
    }
    return true;
});
//# sourceMappingURL=installYeoman.js.map